#include <pic.h>

__CONFIG(0x3FF1);

#define CHARS 11
char text[CHARS]={0xff,0xff,0xff,0x89,0x86,0xc7,0xc7,0xc0,0x7d,0xff,0xff};

void wait(void)
{
  unsigned int i;
  for (i=0; i<255; i++);
}

void main()
{
  unsigned int mask;
  unsigned int idx;
  unsigned int displ;
  unsigned int refrc;

  PORTA = 0xFF; // set PORTA pin values before opening outputs
  TRISA = 0xF0; // set PORTA pin direction: RA0..3 out, RA4 in
  TRISB = 0x00; // PORTB - all pins are outputs

  idx=0;
  for (;;) { // endless loop
    for (refrc=0; refrc<=8; refrc++) {
      mask=0x08;
      for (displ=0; displ<=3; displ++)
      {
        PORTB=text[(idx+displ)%CHARS];
        PORTA=0x0f^mask;
        wait();
        PORTA=0x0f;
        mask>>=1;
      }
    }
    idx=(idx+1)%CHARS;
  }
}
